unit MainUnit;
//   Trie-   ,   
//   .
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, UTrie, ExtCtrls;

type
  TFormMain = class(TForm)
    ButtonOpen: TButton;
    EditWord1: TEdit;
    ButtonAdd: TButton;
    EditWord2: TEdit;
    ButtonRemove: TButton;
    MemoTree: TMemo;
    OpenDialog: TOpenDialog;
    procedure ButtonOpenClick(Sender: TObject);
    procedure ButtonAddClick(Sender: TObject);
    procedure ButtonRemoveClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;
  T: TTrie;

implementation

{$R *.dfm}
 //    "  "
procedure TFormMain.ButtonOpenClick(Sender: TObject);
var i:integer;
    strs:TStringList; //     
begin
 if OpenDialog.Execute then
  begin
   strs:=TStringList.Create;
   strs.LoadFromFile(OpenDialog.FileName);
   for i:=0 to strs.Count-1 do T.Add(strs.Strings[i] );
   strs.Free;
   T.Print(MemoTree.Lines);
  end;
end;

/////    ""
procedure TFormMain.ButtonAddClick(Sender: TObject);
begin
  T.Add(EditWord1.Text);
  T.Print(MemoTree.Lines);
  EditWord1.Text := '';
  EditWord1.SetFocus;
end;

////    ""
procedure TFormMain.ButtonRemoveClick(Sender: TObject);
begin
  T.RemoveStartedWith(EditWord2.Text);
  T.Print(MemoTree.Lines);
end;
//     ,   - .
initialization
  T := TTrie.Create;
finalization
  T.Free;
end.
